<template>
  <div class="notice-page">
    <div style="display: flex; justify-content: end;margin-bottom: 20px">
      <a :class="{'disabled': noReadNoticeCount === 0}" @click="readAll">全部标记为已读</a>
    </div>
    <a-list
        class="demo-loadmore-list"
        item-layout="horizontal"
        :data-source="noticeList"
    >
      <a-list-item slot="renderItem" slot-scope="item">
        <a slot="actions" v-if="item.mail_status == 0" @click="read(item)">标记已读</a>
        <a-badge :dot="item.mail_status == 0">
          <a-list-item-meta
              :title="item.mail_status == 0 ? item.mail_content : ''"
              :description="item.mail_status == 1 ? item.mail_content : ''">
          </a-list-item-meta>
        </a-badge>
      </a-list-item>
    </a-list>
  </div>
</template>

<script>
import {mapActions, mapGetters, mapState} from "vuex";

export default {
  name: "notice",

  computed: {
    ...mapState('notice', ['noticeList']),
    ...mapGetters('notice', ['noReadNoticeCount'])
  },

  methods: {
    ...mapActions('notice', ['getNoticeList']),
    readAll() {
      if (this.noReadNoticeCount === 0) return;
      this.$axios.post('site/mail/readall').then(res => {
        if (res.code == 0) {
          this.$store.state.notice.noticeList = this.noticeList.map(item => {
            item.mail_status = 1
            return item
          })
        } else {
          this.$notification.error({message: '操作失败'})
        }
      }).catch(() => {
        this.$notification.error({message: '操作失败'})
      })
    },

    read(item) {
      this.$axios.get(`site/mail/${item.mail_id}`).then(res => {
        if (res.code == 0) {
          this.$store.state.notice.noticeList = this.noticeList.map(_item => {
            if (_item.mail_id === item.mail_id) {
              _item.mail_status = 1
            }
            return _item
          })
        } else {
          this.$notification.error({message: '操作失败'})
        }
      }).catch(() => {
        this.$notification.error({message: '操作失败'})
      })
    }
  }
}
</script>

<style lang="less" scoped>
  .notice-page {
    padding-top: 40px;
    width: 800px;
    margin: 0 auto;
    /deep/ .ant-badge-dot {
      top: 50%;
      left: -15px;
      transform: translateY(-50%);
    }
    a.disabled {
      color: rgba(0, 0, 0, 0.45);
    }
  }
</style>